<template>
  <v-container class="post text-center">
    <div v-if="loading" class="loading">
      Loading...
    </div>

    <div v-if="error" class="error">
      {{ error }}
    </div>

    <div v-if="post" class="content mb-8">
      <p>{{post.date}}</p>
      <img class="img-fluid post__image" :src="'../' + post.full_image" :alt="post.name" loading="lazy">
      <h1>{{post.name}}</h1>
      <p>{{post.desc}}</p>
    </div>
    <v-form
        ref="form"
        v-model="form"
    >
      <v-textarea
          v-model="newComment"
          auto-grow
          filled
          color="deep-purple"
          label="Your new comment"
          rows="1"
          :rules="[rules.required]"
      ></v-textarea>
    </v-form>
    <div class="mb-8">
      <v-btn
          text
          @click="$refs.form.reset()"
      >
        Clear
      </v-btn>
      <v-btn
          :disabled="!form"
          class="white--text"
          color="deep-purple accent-4"
          depressed
          @click="addComment"
      >
        Submit
      </v-btn>
    </div>
    <template v-if="comments.length">
      <h2>Comments</h2>
      <v-list class="text-left">
        <v-list-item
            style="min-height: 0; border: 1px solid black;"
            v-for="comment in comments"
            :key="comment"
            class="px-3"
        >
          <v-list-item-title v-text="comment" style="white-space: pre-line;"></v-list-item-title>
        </v-list-item>
      </v-list>
    </template>
  </v-container>
</template>

<script>
export default {
  data () {
    return {
      loading: false,
      error: null,
      newComment: '',
      form: false,
      rules: {
        required: v => !!v || 'This field is required',
      },
      comments: []
    }
  },
  created () {
    // fetch the data when the view is created and the data is
    // already being observed
    this.fetchData()
  },
  watch: {
    // call again the method if the route changes
    '$route': 'fetchData'
  },
  methods: {
    fetchData () {
      this.error = null
      this.loading = true
      const fetchedId = this.$route.params.id
      this.$store.dispatch('getArticles')
          .then(() => {
            if (this.$route.params.id !== fetchedId) return
            this.loading = false
          })
          .catch(err => this.error = err.toString())
    },
    addComment() {
      this.comments.push(this.newComment)
      this.$refs.form.reset()
    }
  },
  computed: {
    post () {
      return this.$store.getters.getArticleById(this.$route.params.id)
    }
  }
}
</script>

<style scoped>
.post__image {
  max-height: 480px;
}
</style>